class Ann: Character() {
    init {
        life = 15
    }
    override val name = "安"
    override val id = 6
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(7) { AttackCard(this) }
        arr += MutableList(7) { DefendCard(this) }
        arr += MutableList(5) { HealCard(this) }
        arr += MutableList(5) { SupplyCard(this) }
        arr += MutableList(3) { RobbingCard(this) }
        arr += MutableList(7) { SurpriceCard(this) }
        arr += MutableList(2) { AwareCard(this) }
        arr += MutableList(2) { PlanCard(this) }
        arr += MutableList(5) { SweepCard(this) }
        arr += MutableList(1) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(1) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}

class Guo: Character() {
    init {
        life = 15
    }
    override val name = "圭月"
    override val id = 1
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(7) { AttackCard(this) }
        arr += MutableList(7) { DefendCard(this) }
        arr += MutableList(5) { HealCard(this) }
        arr += MutableList(5) { SupplyCard(this) }
        arr += MutableList(5) { RobbingCard(this) }
        arr += MutableList(5) { SurpriceCard(this) }
        arr += MutableList(3) { AwareCard(this) }
        arr += MutableList(3) { PlanCard(this) }
        arr += MutableList(1) { SweepCard(this) }
        arr += MutableList(1) { BlessCard(this) }
        arr += MutableList(1) { PoisonCard(this) }
        arr += MutableList(1) { ChaosCard(this) }
        arr += MutableList(1) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class May: Character() {
    init {
        life = 15
    }
    override val name = "梅"
    override val id = 3
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(7) { AttackCard(this) }
        arr += MutableList(7) { DefendCard(this) }
        arr += MutableList(6) { HealCard(this) }
        arr += MutableList(6) { SupplyCard(this) }
        arr += MutableList(4) { RobbingCard(this) }
        arr += MutableList(4) { SurpriceCard(this) }
        arr += MutableList(4) { AwareCard(this) }
        arr += MutableList(4) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(1) { BlessCard(this) }
        arr += MutableList(1) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(1) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Rabbit: Character() {
    init {
        life = 12
    }
    override val name = "小兔"
    override val id = 2
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(10) { AttackCard(this) }
        arr += MutableList(4) { DefendCard(this) }
        arr += MutableList(3) { HealCard(this) }
        arr += MutableList(3) { SupplyCard(this) }
        arr += MutableList(5) { RobbingCard(this) }
        arr += MutableList(9) { SurpriceCard(this) }
        arr += MutableList(4) { AwareCard(this) }
        arr += MutableList(2) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(0) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(3) { ChaosCard(this) }
        arr += MutableList(0) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Silver: Character() {
    init {
        life = 15
    }
    override val name = "銀"
    override val id = 8
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(5) { AttackCard(this) }
        arr += MutableList(5) { DefendCard(this) }
        arr += MutableList(5) { HealCard(this) }
        arr += MutableList(5) { SupplyCard(this) }
        arr += MutableList(7) { RobbingCard(this) }
        arr += MutableList(5) { SurpriceCard(this) }
        arr += MutableList(3) { AwareCard(this) }
        arr += MutableList(5) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(2) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(2) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Tadashisaku: Character() {
    init {
        life = 15
    }
    override val name = "正作"
    override val id = 10
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(7) { AttackCard(this) }
        arr += MutableList(7) { DefendCard(this) }
        arr += MutableList(5) { HealCard(this) }
        arr += MutableList(5) { SupplyCard(this) }
        arr += MutableList(5) { RobbingCard(this) }
        arr += MutableList(5) { SurpriceCard(this) }
        arr += MutableList(5) { AwareCard(this) }
        arr += MutableList(5) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(0) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(3) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class W: Character() {
    init {
        life = 12
    }
    override val name = "W"
    override val id = 9
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(4) { AttackCard(this) }
        arr += MutableList(10) { DefendCard(this) }
        arr += MutableList(6) { HealCard(this) }
        arr += MutableList(0) { SupplyCard(this) }
        arr += MutableList(7) { RobbingCard(this) }
        arr += MutableList(7) { SurpriceCard(this) }
        arr += MutableList(4) { AwareCard(this) }
        arr += MutableList(4) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(0) { BlessCard(this) }
        arr += MutableList(3) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(0) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Thunder: Character() {
    init {
        life = 10
    }
    override val name = "桑德"
    override val id = 7
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(5) { AttackCard(this) }
        arr += MutableList(5) { DefendCard(this) }
        arr += MutableList(3) { HealCard(this) }
        arr += MutableList(3) { SupplyCard(this) }
        arr += MutableList(3) { RobbingCard(this) }
        arr += MutableList(3) { SurpriceCard(this) }
        arr += MutableList(2) { AwareCard(this) }
        arr += MutableList(2) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(0) { BlessCard(this) }
        arr += MutableList(2) { PoisonCard(this) }
        arr += MutableList(2) { ChaosCard(this) }
        arr += MutableList(2) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Haier: Character() {
    init {
        life = 12
    }
    override val name = "海爾"
    override val id = 5
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(10) { AttackCard(this) }
        arr += MutableList(4) { DefendCard(this) }
        arr += MutableList(3) { HealCard(this) }
        arr += MutableList(3) { SupplyCard(this) }
        arr += MutableList(7) { RobbingCard(this) }
        arr += MutableList(7) { SurpriceCard(this) }
        arr += MutableList(0) { AwareCard(this) }
        arr += MutableList(0) { PlanCard(this) }
        arr += MutableList(3) { SweepCard(this) }
        arr += MutableList(0) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(4) { ChaosCard(this) }
        arr += MutableList(0) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}
class Yukimura: Character() {
    init {
        life = 18
    }
    override val name = "雪村"
    override val id = 4
    override val deck: Deck by lazy {
        val arr: MutableList<Card> = MutableList(6) { AttackCard(this) }
        arr += MutableList(8) { DefendCard(this) }
        arr += MutableList(7) { HealCard(this) }
        arr += MutableList(3) { SupplyCard(this) }
        arr += MutableList(7) { RobbingCard(this) }
        arr += MutableList(3) { SurpriceCard(this) }
        arr += MutableList(2) { AwareCard(this) }
        arr += MutableList(2) { PlanCard(this) }
        arr += MutableList(0) { SweepCard(this) }
        arr += MutableList(5) { BlessCard(this) }
        arr += MutableList(0) { PoisonCard(this) }
        arr += MutableList(0) { ChaosCard(this) }
        arr += MutableList(2) { ReverseCard(this) }

        val deck = Deck(arr)
        deck.shuffle()
        deck
    }
}